use actix_web::{Responder, web, HttpResponse};
use askama::Template;
use serde::Deserialize;
use sqlx::sqlite::SqlitePool;

use crate::auth::utils::hash_plain_password;
use crate::models::Role;

pub fn init(cfg: &mut web::ServiceConfig) {
    cfg.service(get_login);
    cfg.service(post_login);
    cfg.service(get_register);
    cfg.service(post_register);
}

#[derive(Deserialize)]
struct LoginForm {
    name: String,
    password: String
}

#[derive(Template)]
#[template(path = "login.html")] 
struct LoginTemplate { 
}

#[derive(Template)]
#[template(path = "register.html")] 
struct RegisterTemplate { 
    roles: Vec<Role>
}

#[actix_web::get("/login")]
async fn get_login() -> impl Responder {
    let bla = LoginTemplate {};

    HttpResponse::Ok()
    .body(bla.render().unwrap())
}

#[actix_web::post("/login")]
async fn post_login(web::Form(form): web::Form<LoginForm>) -> impl Responder {
    println!("{} - {}", form.name, form.password);

    let hash = hash_plain_password(&form.password);

    println!("{hash}");

    "dfgdg"
}

#[actix_web::get("/register")]
async fn get_register(pool: web::Data<SqlitePool>) -> impl Responder {
    let roles = match Role::GetAll(pool.get_ref()).await {
        Ok(value) => value,
        Err(error) => return HttpResponse::InternalServerError().body(error.to_string())
    };

    let bla = RegisterTemplate { roles };

    HttpResponse::Ok()
    .body(bla.render().unwrap())
}

#[actix_web::post("/register")]
async fn post_register(web::Form(form): web::Form<LoginForm>) -> impl Responder {
    println!("{} - {}", form.name, form.password);

    let hash = hash_plain_password(&form.password);

    println!("{hash}");

    "dfgdg"
}
