use argon2::{
    password_hash::{rand_core::OsRng, PasswordHash, PasswordHasher,  SaltString},
    Argon2,
};

pub fn hash_plain_password(plain: &str) -> String {
    let salt = SaltString::generate(&mut OsRng);

    // Argon2 with default params (Argon2id v19)
    Argon2::default()
        .hash_password(plain.as_bytes(), &salt)
        .unwrap()
        .to_string()

    // Verify password against PHC string.
    //
    // NOTE: hash params from `parsed_hash` are used instead of what is configured in the
    // `Argon2` instance.
    // PasswordHash::new(&password_hash).unwrap().to_string()
}
