use sqlx::sqlite::SqlitePool;

pub struct Role {
    pub id: u8,
    pub definition: String
}

impl Role {
    pub async fn GetAll(pool: &SqlitePool) -> anyhow::Result<Vec<Role>> {
        let records = sqlx::query!(
            r#"
                SELECT id, definition 
                FROM roles
                ORDER BY id
            "#
        )
        .fetch_all(pool)
        .await?;

        let mut result = Vec::new();

        for record in records {
            let role = Role {
                id: record.id as u8,
                definition: record.definition,
            };
            result.push(role);
        }

        Ok(result)
    }
}
